// Example1.cpp
// AM sound, using a SndThread object
// VL, 2001

#include <SndObj/AudioDefs.h>
#include <string.h>

#ifndef WIN32
#include <unistd.h>
#endif

int
main(int argc, char** argv){

  char command[10];
  int status;
 
// SndObj objects set-up    
  HarmTable table(1024, 1, 1);
  HammingTable window(1024, 0.5);

  int hopsize = 256;
  float stratio = 1.f;
  int synth_hopsize = hopsize*stratio;
//  cout << a << "\n";
  SndWave input("pianoc2.wav", READ,1,16,0,0.f,hopsize);
  //SndPVOCEX inspec("spec2.pvx", READ);

  SndThread thread;
  SndIn   insound(&input, 1, hopsize);
  //SpecIn   inpv(&inspec, 1, 1024);
IFGram ifgram(&window, &insound, 1.f, 1024, hopsize);
SinAnal sinus(&ifgram, 0.01f, 100);
//Ap synth(1000.f, .9f, &insound);
//PVS   synth(&window, &ifgram, 1024, hopsize);
SinSyn  synth(&sinus, 100,&table, 1.f, 2.f, synth_hopsize);
 // SndPVOCEX outspec("sine.wav");
SndWave output("trans.wav", OVERWRITE,1,16,0,0.f,synth_hopsize);
//SndRead synth("sine.wav", 1.f);
//SndRTIO output(1, SND_OUTPUT, 1024);
output.SetOutput(1, &synth);
 // outspec.SetOutput(1, &ifgram);

  // sound thread set-up

 thread.AddObj(&insound);
// thread.AddObj(&inpv);
thread.AddObj(&ifgram);
thread.AddObj(&sinus);
 //read.AddObj(&synth);
   thread.AddObj(&synth);
 thread.AddObj(&input, SNDIO_IN);
 // thread.AddObj(&inspec, SNDIO_IN);
  //thread.AddObj(&outspec, SNDIO_OUT);
 thread.AddObj(&output, SNDIO_OUT); // adds output to the out list
   
  // command loop
//thread.ProcOn();
  while(1){
   
	  if(input.Eof()) {
          status = thread.ProcOff();
		  break;

	  }

   cout << "Type a command: on, off or end\n";
   cin >> command;

   if(!strcmp(command, "on")){ 
    status = thread.ProcOn();// processing ON
       
   }
   if(!strcmp(command, "off"))
     status = thread.ProcOff();
   
   if(!strcmp(command, "end")){ 
    if(status){ // if processing still ON
     status = thread.ProcOff(); 
    #ifndef WIN32
	 sleep(1);
    #endif

      }
     break;
   }	 

  }

  return 1;
}

